<?php
namespace Teknisa\DF\Controllers;

use Teknisa\DF\Services\Ger98700ControleFiscalService;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class Ger98700ControleFiscalController extends \Teknisa\DF\Controllers\TeknisaCrud {

    protected $controleFiscalService;
    protected $dataSourceName = "";
    protected $parameterBagColumns = array();

    public function __construct($crudService, ParameterBag $parameterBag, Ger98700ControleFiscalService $controleFiscalService) {
        $this->controleFiscalService = $controleFiscalService;
        parent::__construct($crudService, $parameterBag);
    }

    public function findTipooperacEncargoImposto(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "tipooperac_encargo_imposto";
        $this->parameterBagColumns = array("IDENTRSAIDOP", "NRORG");
        parent::find($request, $response);
    }

    public function saveTipooperacEncargoImposto(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $this->controleFiscalService->validateTipooperac($row);
            $this->dataSourceName = "tipooperac_encargo_imposto";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function findImpobrigtpoperImposto(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = "impobrigtpoper_imposto";
        $this->parameterBagColumns = array("IDENTRSAIDOP", "NRORG", "CDTIPOOPER");
        parent::find($request, $response);
    }

    public function saveImpobrigtpoperImposto(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0];
            $this->controleFiscalService->validateImpobrigtpoper($row);
            $this->dataSourceName = "impobrigtpoper_imposto";
            parent::save($request, $response);
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function deleteImpobrigtpoperImposto(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = "impobrigtpoper_imposto";
        parent::delete($request, $response);
    }

}