<?php
namespace Teknisa\DF\Modules\Entrada\Controllers;

use Zeedhi\Framework\DTO;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\ParameterBag;

class Dfe45000ParametrosBloquearTipoOperacaoExigeAfController extends \Teknisa\DF\Controllers\TeknisaCrud {
    protected $connection;
    protected $environment;
    protected $dataSourceName = '';

    protected $parambloq_unidade_save_dataSourceName = 'parambloqnfafil';
    protected $parambloq_unidade_dataSourceName = 'parambloqnfafil_unidadeparamsbloq';
    protected $parambloq_fornecedor_save_dataSourceName = 'parambloqnfafor';
    protected $parambloq_fornecedor_dataSourceName = 'parambloqnfafor_fornecedorparamsbloq';

    public function __construct($crudService, ParameterBag $parameterBag, EntityManager $entityManager, $environment) {
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;

        parent::__construct($crudService, $parameterBag);
    }

    public function findTipoOperacFornecedor(DTO\Request\Filter $request, DTO\Response $response) {
        $this->parameterBagColumns = array("P_NRINSJURFORN");

        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->parambloq_fornecedor_dataSourceName;
        
        parent::find($request, $response);
        
        $this->dataSourceName = $previous_dataSourceName;
        $this->parameterBagColumns = array();
    }

    public function findTipoOperacUnidade(DTO\Request\Filter $request, DTO\Response $response) {
        $this->parameterBagColumns = array("P_CDFILIAL");

        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->parambloq_unidade_dataSourceName;
        
        parent::find($request, $response);
        
        $this->dataSourceName = $previous_dataSourceName;
        $this->parameterBagColumns = array();
    }

    public function saveTipoOperacFornecedor(DTO\Request $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->parambloq_fornecedor_save_dataSourceName;

        foreach($request->getDataSet()->getRows() as $row) {
            $params =  array();
            $params["CDFORNECED"] = $row["CDFORNECED"];
            $params["CDTIPOOPER"] = $row["CDTIPOOPER"];
            $params["IDENTRSAIDOP"] = $row["IDENTRSAIDOP"];

            $retornoSelect = $this->getOperacFornecedor($params);

            $row['__is_new'] = ($retornoSelect[0]['ISNEW'] == 'S')? true : false;
        }
        
        parent::save($request, $response);
        
        $this->dataSourceName = $previous_dataSourceName;
    }

    public function saveTipoOperacUnidade(DTO\Request $request, DTO\Response $response) {
        $previous_dataSourceName = $this->dataSourceName;
        $this->dataSourceName = $this->parambloq_unidade_save_dataSourceName;

        foreach($request->getDataSet()->getRows() as $row) {
            $params =  array();
            $params["CDFILIAL"] = $row["CDFILIAL"];
            $params["CDTIPOOPER"] = $row["CDTIPOOPER"];
            $params["IDENTRSAIDOP"] = $row["IDENTRSAIDOP"];

            $retornoSelect = $this->getOperacUnidade($params);

            $row['__is_new'] = ($retornoSelect[0]['ISNEW'] == 'S')? true : false;
        }
        
        parent::save($request, $response);
        
        $this->dataSourceName = $previous_dataSourceName;
    }

    private function getOperacFornecedor($params) {
        $params['NRORG'] = $this->environment->getNrOrgTrab();

        $sql = "SELECT DECODE(count(*), 0, 'S', 'N') AS ISNEW
                  FROM PARAMBLOQNFAFOR
                 WHERE CDFORNECED   = :CDFORNECED
                   AND CDTIPOOPER   = :CDTIPOOPER
                   AND IDENTRSAIDOP = :IDENTRSAIDOP
                   AND NRORG        = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $dataSet = $std->fetchAll();
    }

    private function getOperacUnidade($params) {
        $params['NRORG'] = $this->environment->getNrOrgTrab();

        $sql = "SELECT DECODE(count(*), 0, 'S', 'N') AS ISNEW
                  FROM PARAMBLOQNFAFIL
                 WHERE CDFILIAL     = :CDFILIAL
                   AND CDTIPOOPER   = :CDTIPOOPER
                   AND IDENTRSAIDOP = :IDENTRSAIDOP
                   AND NRORG        = :NRORG";

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $dataSet = $std->fetchAll();
    }
}