<?php
namespace Teknisa\DF\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\DF\Modules\Relatorios\Services\Dfe26000InflacaoInterna;

class ItlanctoestInflcomprasmaisvol extends \Teknisa\DF\Controllers\TeknisaCrud {

	protected $Dfe26000InflacaoInterna;
	protected $dataSourceName = "itlanctoest_inflcomprasmaisvol";
	protected $parameterBagColumns = ["INIMES2",
		"INIMES1",
		"FINMES2",
		"CDOPERENTR",
		"FINMES1",
		"CDFILIAL",
		"CDPRODINI",
		"CDPRODFINAL"];

	public function __construct($crudService, $parameterBag, Dfe26000InflacaoInterna $Dfe26000InflacaoInterna){
		parent::__construct($crudService, $parameterBag);
		$this->Dfe26000InflacaoInterna = $Dfe26000InflacaoInterna;
	}

	public function find(DTO\Request\Filter $request, DTO\Response $response){
		parent::find($request, $response);

		$dataSet = $response->getDataSets();
		if(!empty($dataSet)){
			$rows = $dataSet[0]->getRows();
			$newRows = [];
			if(!empty($rows)){
				foreach ($rows as $index => $value) {
					$inflacao = $this->Dfe26000InflacaoInterna->calculaInflacao($value['VRMES1'], $value['VRMES2']);

					$value['INFLACAO'] = $inflacao;
					$newRows[] = $value;
				}

				$dataSet = new DataSet('itlanctoest_inflcomprasmaisvol', $newRows);
				$response->setDataSets(array($dataSet));
			}
		}
	}
}